using System;
using System.Collections.Generic;
using System.Text;

using System.Runtime.InteropServices;

namespace ARC2
{
    public class NativeMethods
    {
        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        public extern static bool AttachConsole(Int32 pid);

        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        public extern static bool FreeConsole();

        [System.Runtime.InteropServices.DllImport("user32")]
        public static extern int SendInput(int cInputs, ref INPUT pInputs, int cbSize);

        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        private static extern bool AllocConsole();

        [System.Runtime.InteropServices.DllImport("user32.dll", SetLastError = true, CharSet = System.Runtime.InteropServices.CharSet.Auto)]
        public static extern int GetClassName(IntPtr hWnd, [Out] StringBuilder lpString,
        int nMaxCount);


        public struct KEYDBINPUT
        {
            public Int16 wVk;
            public Int16 wScan;
            public Int32 dwFlags;
            public Int32 time;
            public Int32 dwExtraInfo;
            public Int32 __filler1;
            public Int32 __filler2;
        }

        public struct INPUT
        {
            public Int32 type;
            public KEYDBINPUT ki;
        }

        public static int ATTACH_PARENT_PROCESS = -1;
        

        public static void OutputToConsole(string message)
        {
            //AllocConsole();
            //Console.WriteLine(Environment.NewLine + message + Environment.NewLine);
            //FreeConsole();

            const int ATTACH_PARENT_PROCESS = -1;
            AttachConsole(ATTACH_PARENT_PROCESS);
            Console.WriteLine("\n***********************************************\n");
            Console.WriteLine(message);
            Console.WriteLine("***********************************************");
            ReleaseConsole();
        }

        private static void ReleaseConsole()
        {
            FreeConsole();

            //// simulate return pressing
            INPUT input = new INPUT();
            input.type = 1; // INPUT_KEYBOARD
            input.ki.wVk = 0x0D; // VK_RETURN
            SendInput(1, ref input, System.Runtime.InteropServices.Marshal.SizeOf(input));
            //input.ki.dwFlags = 2; // KEYEVENTF_KEYUP
            //SendInput(1, ref input, System.Runtime.InteropServices.Marshal.SizeOf(input));

            
           
        }

    }
}
