using System;
using System.Collections.Generic;
using System.Text;

namespace ARC2
{
    public class Validation
    {

        /// <summary>
        /// Checks if the current settings are valid 
        /// </summary>
        /// <param name="CloseAppOnError">If true, the application is closed after displaying info</param>
        /// <returns>True if the settings are valid</returns>
        //public static bool ValidateSettings(ref string targetHost,ref string targetPort, ref string password, ref string sessionId, ref int retries, bool OutputToConsoleAndExit, bool ShowInfoBox)
        //{
        //    bool settingsValidated = false;
        //    StringBuilder feedback = new StringBuilder();
        //    int _tmpInt;

        //    if (string.IsNullOrEmpty(targetHost))
        //    {
        //        feedback.AppendLine("Viewer/Repeater address missing");
        //    }

        //    if (string.IsNullOrEmpty(targetPort))
        //    {
        //        targetPort = "5500";
        //    }

        //    if (!Int32.TryParse(targetPort, out _tmpInt))
        //    {
        //        feedback.AppendLine("Invalid port number specified");
        //    }
        //    else
        //    {
        //        if (_tmpInt > 65535 || _tmpInt < 1)
        //        {
        //            feedback.AppendLine("Invalid port number specified");
        //        }
        //    }

        //    if (string.IsNullOrEmpty(sessionId)==false)
        //    {
        //        if (!Int32.TryParse(sessionId, out _tmpInt))
        //        {
        //            feedback.AppendLine("Session ID must be numeric");
        //        }
        //        else
        //        {
        //            sessionId = _tmpInt.ToString();
        //            if (_tmpInt < 1 || _tmpInt > 9999)
        //            {
        //                feedback.AppendLine("Session ID must be between 1 and 9999");
        //            }
        //        }
        //    }
        //    else
        //    {
        //        sessionId = "";
        //    }

        //    //No validation of password

            

        //    if (feedback.Length > 0)
        //    {
        //        settingsValidated = false;

        //        if (CloseAppOnError == true)
        //        {
        //            timerAutoClose.Start();
        //        }
        //        MessageBox.Show(feedback.ToString(), "Invalid settings");

        //    }
        //    else
        //    {
        //        settingsValidated = true;

        //        if (_reconnectTime > 0)
        //        {
        //            timerIdleTimeMax.Interval = _reconnectTime * 1000 * 60;
        //            timerIdleTimeMax.Start();
        //            Console.WriteLine("Starting timer - interval =" + timerIdleTimeMax.Interval / 60000);
        //        }

        //        if (_reconnectTime != 0)
        //        {
        //            _reconnect = true;
        //        }
        //    }

        //    return settingsValidated;

        //}

        public static bool ValidateCommandLine()
        {
            StringBuilder feedback = new StringBuilder();

            string[] args = Environment.GetCommandLineArgs();

            if (args.Length > 1)//invoked with cmd line arguments, so handle them
            {
                //Direct : -connectTo hostname (-port 5500) (-password pwd) (-retries -1) (-dontautoshutdown)
                //Repeater : -connectTo hostname (-port 5500) (-password pwd) -id asdf (-retries -1) (-dontautoshutdown)

                for (int f = 0; f < args.Length; f++)
                {
                    switch (args[f].ToLower())
                    {
                        case "-connectto":
                            if (f + 1 >= args.Length)
                            {
                                feedback.AppendLine("Missing value for -connectTo");
                            }
                            else
                                ARC2.Program.targetHost= args[f + 1];
                            break;
                        case "-port":
                            if (f + 1 >= args.Length)
                            {
                                feedback.AppendLine("Missing value for -port");
                            }
                            else
                            {
                                int _tmpInt=0;
                                if(Int32.TryParse(args[f + 1],out _tmpInt)==false)
                                {
                                feedback.AppendLine("Specified port invalid");
                                }
                                else
                                {
                                    ARC2.Program.targetPort=_tmpInt;
                                    if (ARC2.Program.targetPort > 65535 || ARC2.Program.targetPort < 1)
                                    {
                                        feedback.AppendLine("Specified port invalid - must be in the range 1-65535");
                                    }
                                }
                            }
                            break;
                        case "-password":
                            if (f + 1 >= args.Length)
                            {
                                feedback.AppendLine("Missing value for -password");
                            }
                            else
                            {
                                ARC2.Program.sessionPassword = args[f + 1];
                                if (ARC2.Program.sessionPassword.Length > 7)
                                {
                                    feedback.AppendLine("Maximum length of password is 7 characters");
                                }
                            }
                                
                            break;
                        case "-id":
                            if (f + 1 >= args.Length)
                            {
                                feedback.AppendLine("Missing value for -id");
                            }
                            else
                            {
                                int _tmpInt = 0;
                                if (Int32.TryParse(args[f + 1], out _tmpInt) == false)
                                {
                                    feedback.AppendLine("Specified id invalid - not a number");
                                }
                                else
                                {
                                    ARC2.Program.sessionID = _tmpInt.ToString();
                                    if (_tmpInt > 9999 || _tmpInt < 1)
                                    {
                                        feedback.AppendLine("Specified id invalid - must be in the range 1-9999");
                                    }
                                }
                            }
                             //   radioButtonViaRepeater.Checked = true;
                            //textBoxSessionID.Text = args[f + 1];
                            break;
                        case "-retries":
                            if (f + 1 >= args.Length)
                            {
                                feedback.AppendLine("Missing value for -retries");
                            }
                            else
                            {
                                int _tmpInt = 0;
                                if (Int32.TryParse(args[f + 1], out _tmpInt) == false)
                                { //Failed to parse
                                    feedback.AppendLine("Invalid value for -retries, not a number");
                                }
                                else//Parsed ok
                                {
                                    if (_tmpInt < -1 || _tmpInt > 5)
                                    {
                                        feedback.AppendLine("Value for -retries outside allowed range : -1 to 5");
                                    }
                                    else//All ok
                                    {
                                        ARC2.Program.retries = _tmpInt;
                                        
                                    }
                                }
                            }

                            break;
                        case "-dontautoshutdown":
                            ARC2.Program.autoShutdown = false;
                            break;
                        default:
                            break;

                    }
                }

                if (string.IsNullOrEmpty(ARC2.Program.targetHost))
                {
                    feedback.AppendLine("No target host specified - aborting");
                }

                //Missing/invalid value(s) encountered - bail out


                if (feedback.Length > 0)
                {
                    //timerAutoClose.Start();
                    //MessageBox.Show(feedback.ToString(), "Invalid command line");

                    LogClass.LogErrorToDisk(feedback.ToString());
                    //NativeMethods.OutputToConsole(feedback.ToString());

                    return false;
                }

                
            }
            return true;
        }

        public static bool ValidateApplicationSettings()
        {
            try
            {

                Properties.Settings currentSettings = new ARC2.Properties.Settings();
                StringBuilder feedback = new StringBuilder();

                ARC2.Program.targetHost = currentSettings.ConnectTo;


                ARC2.Program.targetPort = currentSettings.Port;
                if (ARC2.Program.targetPort > 65535 || ARC2.Program.targetPort < 1)
                {
                    feedback.AppendLine("Specified port invalid - must be in the range 1-65535");
                }

                ARC2.Program.sessionPassword = currentSettings.Password;
                if (ARC2.Program.sessionPassword.Length > 7)
                {
                    feedback.AppendLine("Maximum length of password is 7 characters");
                }

                if (!string.IsNullOrEmpty(currentSettings.SessionID))
                {
                    Int32 _tmpInt = 0;
                    if (Int32.TryParse(currentSettings.SessionID, out _tmpInt))
                    {
                        if (_tmpInt > 9999 || _tmpInt < 1)
                        {
                            feedback.AppendLine("Specified id invalid - must be in the range 1-9999");
                        }
                        else
                        {
                            ARC2.Program.sessionID = currentSettings.SessionID;
                        }
                    }
                    else
                    {
                            feedback.AppendLine("Specified id invalid - not a number");
                    }
                }
                else
                {
                    ARC2.Program.sessionID = "";
                }

                ARC2.Program.retries = currentSettings.Retries;

                if (ARC2.Program.retries < -1 || ARC2.Program.retries > 5)
                {
                    feedback.AppendLine("Value for -retries outside allowed range : -1 to 5");
                }

                ARC2.Program.autoShutdown = currentSettings.AutoShutdown; ;



                //Missing/invalid value(s) encountered - bail out
                if (feedback.Length > 0)
                {
                    LogClass.LogErrorToDisk(feedback.ToString());
                    //NativeMethods.OutputToConsole(feedback.ToString());

                    return false;
                }

                return true;

            }
            catch (Exception ex)
            {
                string errorDescription = "Error reading/parsing application settings:\n" +
                "Exception Message :" + ex.Message+"\n" +
                "Stacktrace : " + ex.StackTrace;
                LogClass.LogErrorToDisk(errorDescription);
                //NativeMethods.OutputToConsole(errorDescription);
            }
            return false;
        }

    }
}
